zoukankan      html  css  js  c++  java
  • Codeforces Round #576 (Div. 1) 简要题解 (CDEF)

    1198 C Matching vs Independent Set

    大意: 给定$3n$个点的无向图, 求构造$n$条边的匹配, 或$n$个点的独立集.

    假设已经构造出$x$条边的匹配, 那么剩余$3n-2x$个点, 若$x<n$, 则$3n-2xge n$可以构造出独立集. 

    #include <iostream>
    #include <sstream>
    #include <algorithm>
    #include <cstdio>
    #include <math.h>
    #include <set>
    #include <map>
    #include <queue>
    #include <string>
    #include <string.h>
    #include <bitset>
    #define REP(i,a,n) for(int i=a;i<=n;++i)
    #define PER(i,a,n) for(int i=n;i>=a;--i)
    #define hr putchar(10)
    #define pb push_back
    #define lc (o<<1)
    #define rc (lc|1)
    #define mid ((l+r)>>1)
    #define ls lc,l,mid
    #define rs rc,mid+1,r
    #define x first
    #define y second
    #define io std::ios::sync_with_stdio(false)
    #define endl '
    '
    #define DB(a) ({REP(__i,1,n) cout<<a[__i]<<' ';hr;})
    using namespace std;
    typedef long long ll;
    typedef pair<int,int> pii;
    const int P = 1e9+7, INF = 0x3f3f3f3f;
    ll gcd(ll a,ll b) {return b?gcd(b,a%b):a;}
    ll qpow(ll a,ll n) {ll r=1%P;for (a%=P;n;a=a*a%P,n>>=1)if(n&1)r=r*a%P;return r;}
    ll inv(ll x){return x<=1?1:inv(P%x)*(P-P/x)%P;}
    inline int rd() {int x=0;char p=getchar();while(p<'0'||p>'9')p=getchar();while(p>='0'&&p<='9')x=x*10+p-'0',p=getchar();return x;}
    //head
    
    
    
    const int N = 1e6+10;
    int u[N], v[N], a[N], vis[N];
    
    void work() {
        int n, m;
        scanf("%d%d", &n, &m);
        int cnt = 0;
        REP(i,1,3*n) vis[i] = 0;
        REP(i,1,m) {
            scanf("%d%d", u+i, v+i);
            if (!vis[u[i]]&&!vis[v[i]]&&cnt<n) {
                a[i]=vis[u[i]]=vis[v[i]]=1;
                ++cnt;
            }
            else a[i] = 0;
        }
        if (cnt==n) {
            puts("Matching");
            REP(i,1,m) if (a[i]) printf("%d ",i);
        }
        else {
            puts("IndSet");
            cnt = 0;
            REP(i,1,3*n) if (!vis[i]) {
                printf("%d ",i);
                if (++cnt==n) break;
            }
        }
        puts("");
    }
    
    int main() {
        int t;
        scanf("%d", &t);
        while (t--) work();
    }
    View Code

    1198 D Rectangle Painting 1

    大意: 给定$n^2$棋盘, 每个格子黑或白, 每次操作选择一个$w imes h$的矩形染成白色, 花费为$max(w,h)$, 求最少花费使得棋盘全白.

    范围很小, 直接暴力区间$dp$吧. 

    #include <iostream>
    #include <sstream>
    #include <algorithm>
    #include <cstdio>
    #include <math.h>
    #include <set>
    #include <map>
    #include <queue>
    #include <string>
    #include <string.h>
    #include <bitset>
    #define REP(i,a,n) for(int i=a;i<=n;++i)
    #define PER(i,a,n) for(int i=n;i>=a;--i)
    #define hr putchar(10)
    #define pb push_back
    #define lc (o<<1)
    #define rc (lc|1)
    #define mid ((l+r)>>1)
    #define ls lc,l,mid
    #define rs rc,mid+1,r
    #define x first
    #define y second
    #define io std::ios::sync_with_stdio(false)
    #define endl '
    '
    #define DB(a) ({REP(__i,1,n) cout<<a[__i]<<' ';hr;})
    using namespace std;
    typedef long long ll;
    typedef pair<int,int> pii;
    const int P = 1e9+7, INF = 0x3f3f3f3f;
    ll gcd(ll a,ll b) {return b?gcd(b,a%b):a;}
    ll qpow(ll a,ll n) {ll r=1%P;for (a%=P;n;a=a*a%P,n>>=1)if(n&1)r=r*a%P;return r;}
    ll inv(ll x){return x<=1?1:inv(P%x)*(P-P/x)%P;}
    inline int rd() {int x=0;char p=getchar();while(p<'0'||p>'9')p=getchar();while(p>='0'&&p<='9')x=x*10+p-'0',p=getchar();return x;}
    //head
    
    
    
    const int N = 55;
    int n;
    char s[N];
    int sum[N][N], dp[N][N][N][N];
    
    int get(int a, int b, int c, int d) {
        --a,--b;
        return sum[c][d]-sum[a][d]-sum[c][b]+sum[a][b];
    }
    void chkmin(int &x, int y) {x>y?x=y:0;}
    int main() {
        scanf("%d", &n);
        REP(i,1,n) {
            scanf("%s", s+1);
            REP(j,1,n) sum[i][j]=sum[i-1][j]+sum[i][j-1]-sum[i-1][j-1]+(s[j]=='#');
        }
        REP(j,1,n) PER(i,1,j) REP(b,1,n) PER(a,1,b) if (get(i,a,j,b)) { 
            int &r = dp[i][a][j][b] = max(b-a+1,j-i+1);
            REP(x,a,b-1) {
                chkmin(r,dp[i][a][j][x]+dp[i][x+1][j][b]);
            }
            REP(x,i,j-1) {
                chkmin(r,dp[i][a][x][b]+dp[x+1][a][j][b]);
            }
        }
        printf("%d
    ",dp[1][1][n][n]);
    }
    View Code

    1198 E Rectangle Painting 2

    大意: $1198D$的花费改为$min(w,h)$.

    因为花费是取$min$, 那么相当于每次可以选一行或一列染成白色, 所以可以离散化以后转化为二分图最小带权覆盖问题. 可以参考poj2226

    #include <iostream>
    #include <sstream>
    #include <algorithm>
    #include <cstdio>
    #include <math.h>
    #include <set>
    #include <map>
    #include <queue>
    #include <string>
    #include <string.h>
    #include <bitset>
    #define REP(i,a,n) for(int i=a;i<=n;++i)
    #define PER(i,a,n) for(int i=n;i>=a;--i)
    #define hr putchar(10)
    #define pb push_back
    #define lc (o<<1)
    #define rc (lc|1)
    #define mid ((l+r)>>1)
    #define ls lc,l,mid
    #define rs rc,mid+1,r
    #define x first
    #define y second
    #define io std::ios::sync_with_stdio(false)
    #define endl '
    '
    #define DB(a) ({REP(__i,1,n) cout<<a[__i]<<' ';hr;})
    using namespace std;
    
    const int N = 1e6+10, S = N-2, T = N-1, INF = 0x3f3f3f3f;
    int n, m;
    int vx[N], vy[N];
    struct {int x1,y1,x2,y2;} a[N];
    struct edge {
        int to,w,next;
        edge(int to=0,int w=0,int next=0):to(to),w(w),next(next){}
    } e[N];
    int head[N], dep[N], vis[N], cur[N], cnt=1;
    queue<int> Q;
    int bfs() {
        REP(i,1,*vx+*vy) dep[i]=INF,vis[i]=0,cur[i]=head[i];
        dep[S]=INF,vis[S]=0,cur[S]=head[S];
        dep[T]=INF,vis[T]=0,cur[T]=head[T];
        dep[S]=0,Q.push(S);
        while (Q.size()) {
            int u = Q.front(); Q.pop();
            for (int i=head[u]; i; i=e[i].next) {
                if (dep[e[i].to]>dep[u]+1&&e[i].w) {
                    dep[e[i].to]=dep[u]+1;
                    Q.push(e[i].to);
                }
            }
        }
        return dep[T]!=INF;
    }
    int dfs(int x, int w) {
        if (x==T) return w;
        int used = 0;
        for (int i=cur[x]; i; i=e[i].next) {
            cur[x] = i;
            if (dep[e[i].to]==dep[x]+1&&e[i].w) {
                int f = dfs(e[i].to,min(w-used,e[i].w));
                if (f) used+=f,e[i].w-=f,e[i^1].w+=f;
                if (used==w) break;
            }
        }
        return used;
    }
    int dinic() {
        int ans = 0;
        while (bfs()) ans+=dfs(S,INF);
        return ans;
    }
    void add(int u, int v, int w) {
        e[++cnt] = edge(v,w,head[u]);
        head[u] = cnt;
        e[++cnt] = edge(u,0,head[v]);
        head[v] = cnt;
    } 
    
    
    int main() {
        int n, m;
        scanf("%d%d", &n, &m);
        if (!m) return puts("0"),0;
        REP(i,1,m) {
            scanf("%d%d%d%d", &a[i].x1, &a[i].y1, &a[i].x2, &a[i].y2);
            vx[++*vx] = a[i].x1;
            vx[++*vx] = ++a[i].x2;
            vy[++*vy] = a[i].y1;
            vy[++*vy] = ++a[i].y2;
        }
        sort(vx+1,vx+1+*vx);
        sort(vy+1,vy+1+*vy);
        *vx = unique(vx+1,vx+1+*vx)-vx-1;
        *vy = unique(vy+1,vy+1+*vy)-vy-1;
        REP(i,1,m) {
            a[i].x1 = lower_bound(vx+1,vx+1+*vx,a[i].x1)-vx;
            a[i].x2 = lower_bound(vx+1,vx+1+*vx,a[i].x2)-vx-1;
            a[i].y1 = lower_bound(vy+1,vy+1+*vy,a[i].y1)-vy;
            a[i].y2 = lower_bound(vy+1,vy+1+*vy,a[i].y2)-vy-1;
            REP(x,a[i].x1,a[i].x2) REP(y,a[i].y1,a[i].y2) {
                add(x,y+*vx,INF);
            }
        }
        REP(i,1,*vx-1) add(S,i,vx[i+1]-vx[i]);
        REP(i,1,*vy-1) add(*vx+i,T,vy[i+1]-vy[i]);
        printf("%d
    ", dinic());
    }
    View Code

    1198 F GCD Groups 2

    大意: 给定$n$个数, 求划分为两个集合, 使得每个集合所有元素的$gcd$相同.

  • 相关阅读:
    python dict 与json的运用
    request各种请求的封装
    图片上传两种第三方库调用的封装函数
    JWT Token 生成与token的解析
    如何将windows文件传至linux
    windows 下python 环境安装
    shell的条件测试
    shell的数值运算
    shell基础认知
    cookie和代理
  • 原文地址:https://www.cnblogs.com/uid001/p/11273730.html
Copyright © 2011-2022 走看看